CMSIS-DSP: Complex Matrix Multiplication

| CMSIS-DSP Version 1.4.7 CMSIS DSP Software Library

- Main Page
- Usage and Description
- Reference

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Functions
Complex Matrix Multiplication
Matrix Functions

## Functions
arm_status | arm_mat_cmplx_mult_f32 (const arm_matrix_instance_f32 *pSrcA, const arm_matrix_instance_f32 *pSrcB, arm_matrix_instance_f32 *pDst)
| Floating-point Complex matrix multiplication.
arm_status | arm_mat_cmplx_mult_q15 (const arm_matrix_instance_q15 *pSrcA, const arm_matrix_instance_q15 *pSrcB, arm_matrix_instance_q15 *pDst, q15_t *pScratch)
| Q15 Complex matrix multiplication.
arm_status | arm_mat_cmplx_mult_q31 (const arm_matrix_instance_q31 *pSrcA, const arm_matrix_instance_q31 *pSrcB, arm_matrix_instance_q31 *pDst)
| Q31 Complex matrix multiplication.

## Description

Complex Matrix multiplication is only defined if the number of columns of the first matrix equals the number of rows of the second matrix. Multiplying an `M x N` matrix with an `N x P` matrix results in an `M x P` matrix. When matrix size checking is enabled, the functions check: (1) that the inner dimensions of `pSrcA` and `pSrcB` are equal; and (2) that the size of the output matrix equals the outer dimensions of `pSrcA` and `pSrcB`.

## Function Documentation

arm_status arm_mat_cmplx_mult_f32 | ( | const arm_matrix_instance_f32 * | pSrcA,
|  | const arm_matrix_instance_f32 * | pSrcB,
|  | arm_matrix_instance_f32 * | pDst
| ) |  |

Floating-point, complex, matrix multiplication.

Parameters

  [in] | *pSrcA | points to the first input complex matrix structure
  [in] | *pSrcB | points to the second input complex matrix structure
  [out] | *pDst | points to output complex matrix structure

Returns
  The function returns either `ARM_MATH_SIZE_MISMATCH` or `ARM_MATH_SUCCESS` based on the outcome of size checking.

References ARM_MATH_SIZE_MISMATCH, ARM_MATH_SUCCESS, arm_matrix_instance_f32::numCols, arm_matrix_instance_f32::numRows, arm_matrix_instance_f32::pData, and status.

arm_status arm_mat_cmplx_mult_q15 | ( | const arm_matrix_instance_q15 * | pSrcA,
|  | const arm_matrix_instance_q15 * | pSrcB,
|  | arm_matrix_instance_q15 * | pDst,
|  | q15_t * | pScratch
| ) |  |

Q15, complex, matrix multiplication.

Parameters

  [in] | *pSrcA | points to the first input complex matrix structure
  [in] | *pSrcB | points to the second input complex matrix structure
  [out] | *pDst | points to output complex matrix structure
  [in] | *pScratch | points to the array for storing intermediate results

Returns
  The function returns either `ARM_MATH_SIZE_MISMATCH` or `ARM_MATH_SUCCESS` based on the outcome of size checking.

Conditions for optimum performance
  Input, output and state buffers should be aligned by 32-bit

Restrictions
  If the silicon does not support unaligned memory access enable the macro UNALIGNED_SUPPORT_DISABLE In this case input, output, scratch buffers should be aligned by 32-bit

Scaling and Overflow Behavior:

  The function is implemented using a 64-bit internal accumulator. The inputs to the multiplications are in 1.15 format and multiplications yield a 2.30 result. The 2.30 intermediate results are accumulated in a 64-bit accumulator in 34.30 format. This approach provides 33 guard bits and there is no risk of overflow. The 34.30 result is then truncated to 34.15 format by discarding the low 15 bits and then saturated to 1.15 format.

  Refer to `arm_mat_mult_fast_q15()` for a faster but less precise version of this function.

References __SIMD32, ARM_MATH_SIZE_MISMATCH, ARM_MATH_SUCCESS, arm_matrix_instance_q15::numCols, arm_matrix_instance_q15::numRows, arm_matrix_instance_q15::pData, and status.

arm_status arm_mat_cmplx_mult_q31 | ( | const arm_matrix_instance_q31 * | pSrcA,
|  | const arm_matrix_instance_q31 * | pSrcB,
|  | arm_matrix_instance_q31 * | pDst
| ) |  |

Q31, complex, matrix multiplication.

Parameters

  [in] | *pSrcA | points to the first input complex matrix structure
  [in] | *pSrcB | points to the second input complex matrix structure
  [out] | *pDst | points to output complex matrix structure

Returns
  The function returns either `ARM_MATH_SIZE_MISMATCH` or `ARM_MATH_SUCCESS` based on the outcome of size checking.

Scaling and Overflow Behavior:

  The function is implemented using an internal 64-bit accumulator. The accumulator has a 2.62 format and maintains full precision of the intermediate multiplication results but provides only a single guard bit. There is no saturation on intermediate additions. Thus, if the accumulator overflows it wraps around and distorts the result. The input signals should be scaled down to avoid intermediate overflows. The input is thus scaled down by log2(numColsA) bits to avoid overflows, as a total of numColsA additions are performed internally. The 2.62 accumulator is right shifted by 31 bits and saturated to 1.31 format to yield the final result.

References ARM_MATH_SIZE_MISMATCH, ARM_MATH_SUCCESS, clip_q63_to_q31(), arm_matrix_instance_q31::numCols, arm_matrix_instance_q31::numRows, arm_matrix_instance_q31::pData, and status.